<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

class p_imperavi_redactor extends cmsPlugin {
    
    public static $one_time = false;

// ========================================================================== //

    public function __construct(){
        
        parent::__construct();

        $this->info['plugin']           = 'p_imperavi_redactor';
        $this->info['title']            = 'Imperavi Redactor';
        $this->info['description']      = 'Визуальный редактор <a href="http://imperavi.com/redactor/" target="_blank">Imperavi Redactor</a>';
        $this->info['author']           = 'Автор плагина: <a href="http://www.instantcms.ru/users/lokanaft#upr_p_services">lokanaft</a>';
        $this->info['version']          = '0.1b';
        $this->info['type']             = 'wysiwyg';

        $this->events[]                 = 'INSERT_WYSIWYG';

    }

// ========================================================================== //

    public function execute($event, $item){

        parent::execute();

        //$inUser = cmsUser::getInstance();
        $options = array();
        $get_script = array();
        $get_script_tail = array();
        $s = '';
        
        //плагины
        $options['plugins'] = array(
            'clips',
            'fontfamily',
            'fontsize',
            'fullscreen',
            'textdirection',
            'fontcolor'
        );
        foreach($options['plugins'] as $plugin){
            $get_script[] = '$.getScript("/plugins/p_imperavi_redactor/redactor/plugins/'.$plugin.'/'.$plugin.'.js", function(){';
            $get_script_tail[] = '})';
        }
        //о ужас
        if(in_array('clips', $options['plugins'])){
            $s .= '<link href="/plugins/p_imperavi_redactor/redactor/plugins/clips/clips.css" rel="stylesheet" type="text/css" />';
            $s .= '<div id="clipsmodal" style="display: none;">
			<section>
				<ul class="redactor_clips_box">
					<li>
						<a href="#" class="redactor_clip_link">Lorem ipsum …</a>

						<div class="redactor_clip" style="display: none;">
							Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
						</div>
					</li>
					<li>
						<a href="#" class="redactor_clip_link">Red label</a>

						<div class="redactor_clip" style="display: none;">
							<span class="label-red">Label</span>
						</div>
					</li>
				</ul>
			</section>
			<footer>
				<a href="#" class="redactor_modal_btn redactor_btn_modal_close">Close</a>
			</footer>
		</div>';
        }

        //файл языка
        if(cmsConfig::getConfig('lang') !== 'en'){
            $get_script[] = '$.getScript("/plugins/p_imperavi_redactor/redactor/lang/'.cmsConfig::getConfig('lang').'.js", function(){';
            $get_script_tail[] = '})';
            $options['lang'] = cmsConfig::getConfig('lang');
        }
        
        //конвертирование ссылок vimeo и youtube
        $options['convertVideoLinks'] = true;
        
        //вставка из буфера обмена
        $options['clipboardUploadUrl'] = '/plugins/p_imperavi_redactor/uploader.php';
        
        //заливка картинок перетаскиванием
        $options['imageUpload'] = '/plugins/p_imperavi_redactor/uploader.php';
        

        if(!self::$one_time){
            $s .= '<style>textarea.imperavi_redactor{background:none}</style>';
            $s .= '<link href="/plugins/p_imperavi_redactor/redactor/redactor.css" rel="stylesheet" type="text/css" />';
            $s .= '<script type="text/javascript">$(document).ready(function(){
                        $.getScript("http://code.jquery.com/jquery-latest.min.js",
                                                function(){
                                                var jquery_new = jQuery;
                        $.getScript("/plugins/p_imperavi_redactor/redactor/redactor.js",
                            function(){
                                '.implode("\r\n", $get_script).'
                                    FCK_EDITMODE_WYSIWYG = true;
                                    FCKeditorAPI = {
                                        selector: null,
                                        EditMode: true,
                                        GetInstance: function(selector) {
                                            this.selector = $("textarea[name=\'"+selector+"\']");
                                            return this;},
                                        InsertHtml: function(text) {
                                            jquery_new("textarea[name=\'content\']").redactor("insertHtml", text);
                                        }
                                    };
                                    $(".imperavi_redactor").redactor('.json_encode($options).');
                                    $.getScript("/includes/jquery/jquery.js", function(){})
                                '.implode("\r\n", $get_script_tail).'
                        })
                        })
                    });</script>';
            self::$one_time = true;
        }
        
        $_SESSION['imperavi_redactor'] = true;
        
        return $s.'<textarea class="imperavi_redactor" name="'.$item['name'].'" style="width:'.(is_numeric($item['width']) ? $item['width'].'px' : $item['width']).';height:'.(is_numeric($item['height']) ? $item['height'].'px' : $item['height']).'">'.$item['text'].'</textarea>';
        
    }

}
